<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow  xmlns:fx="http://ns.adobe.com/mxml/2009"
				xmlns:s="library://ns.adobe.com/flex/spark"
				xmlns:ui="library://ns.adobe.com/flex/ui"
				xmlns:mx="library://ns.adobe.com/flex/mx"
				xmlns:components="br.com.dclick.components.*"
				xmlns:componente="br.com.desenv.framework.componente.*"
				close="titlewindowCloseHandler(event)"  
				creationComplete="creationCompleteHandler(event)"
				keyDown="titlewindow1_keyDownHandler(event)"
				title="Multiplas Baixas"
				maxWidth="1200" maxHeight="700"  
				xmlns:visual="br.com.desenv.framework.component.visual.*"   xmlns:autoComplete="br.com.desenv.framework.component.visual.autoComplete.*">
	
	<fx:Style source="../../../framework/util/estilo.css"/>

	
	<fx:Metadata>
		[Event(name="BaixaLancamentoContaPagarAtualizadoEvent")]
	</fx:Metadata>
	
	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			import flash.utils.getQualifiedClassName;
			
			
			import mx.controls.DateField;
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.validators.Validator;
			
			import spark.events.TitleWindowBoundsEvent;
			
			import br.com.desenv.nepalign.vo.BaixaLancamentoContaPagar;
			import br.com.desenv.nepalign.vo.ContaCorrente;
			import br.com.desenv.nepalign.vo.FormaPagamento;
			import br.com.desenv.nepalign.vo.LancamentoContaPagar;
			import br.com.desenv.nepalign.vo.SituacaoLancamento;
			
			[Bindable]
			public var listaLancamentoContaPagar: ArrayCollection = new ArrayCollection();
			[Bindable]
			private var listaContaCorrente: ArrayCollection = new ArrayCollection();
			[Bindable]
			private var listaFormaPagamento: ArrayCollection = new ArrayCollection();
			[Bindable]
			public var lancamentoContaPagar: LancamentoContaPagar;
			[Bindable]
			private var listaSituacaoLancamento:ArrayCollection = new ArrayCollection();
			[Bindable]
			private var listaBaixaLancamentoContaPagarExcluir:ArrayCollection = new ArrayCollection();
			[Bindable]
			protected var listaBaixaLancamentoContaPagar:ArrayCollection = new ArrayCollection();
			
			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			private function carregarListaValidacao(): void
			{
				
			}
			
			private function limparListaCampo(): void
			{
				ignComboBoxAutoCompleteFormaPagamento.selectedIndex = -1;
				ignAutoCompleteContaCorrente.limpar();
				ignTextInputDateDataPagamento.text = "";
				ignComboBoxFixoConsiderarBaixaIntegral.selectedIndex = -1;
				ignTextInputObservacao.text = "";
			}
			
			private function montarObjetoFiltroBaixa():BaixaLancamentoContaPagar
			{
				var baixaLancamentoContaPagarFiltro:BaixaLancamentoContaPagar = new BaixaLancamentoContaPagar();
				baixaLancamentoContaPagarFiltro.lancamentoContaPagar = this.lancamentoContaPagar;
				return baixaLancamentoContaPagarFiltro;
			}
			
			private function creationCompleteHandler( event: FlexEvent ): void 
			{
				this.setFocus();
				focusManager.getNextFocusManagerComponent().setFocus();
				
				carregarListaValidacao();
				
				var remoteObjectFormaPagamento: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("formaPagamentoService", listarFormaPagamentoResultHandler);	
				remoteObjectFormaPagamento.getOperation("listar").send();
				
				var remoteObjectSituacaoLancamento: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("situacaoLancamentoService", listarSituacaoLancamentoResultHandler);	
				remoteObjectSituacaoLancamento.getOperation("listar").send();
				
				limparListaCampo();
				//this.ignTextInputDateDataPagamento.text = DateField.dateToString(this.lancamentoContaPagar.dataVencimento, "DD/MM/YYYY");
			}
			
			private function listarFormaPagamentoResultHandler( event: ResultEvent ): void 
			{
				listaFormaPagamento = event.result as ArrayCollection;
				listaFormaPagamento.addItemAt(null, 0);
			}
			
			private function listarSituacaoLancamentoResultHandler(event:ResultEvent):void
			{
				this.listaSituacaoLancamento.addAll(event.result as ArrayCollection);
			}
			
			protected function recuperarSituacaoLancamentoPorId(id:Number):SituacaoLancamento
			{
				for each(var obj:Object in this.listaSituacaoLancamento)
				{
					var situacaoLancamento:SituacaoLancamento = obj as SituacaoLancamento;
					if(situacaoLancamento.id == id)
						return situacaoLancamento;
				}
				return null;
			}
			
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this); 
			}
			
			protected function disableAllFields():void
			{
				this.ignAutoCompleteContaCorrente.enabled = false;
				this.ignComboBoxAutoCompleteFormaPagamento.enabled = false;
				this.ignComboBoxFixoConsiderarBaixaIntegral.enabled = false;
				this.ignTextInputDateDataPagamento.enabled = false;
				this.ignTextInputObservacao.enabled = false;
			}
		
			private function buttonSalvar_clickHandler( event: MouseEvent ): void 
			{
				var baixaLancamentoContaPagar:BaixaLancamentoContaPagar = new BaixaLancamentoContaPagar();
				try
				{
					baixaLancamentoContaPagar.contaCorrente = this.ignAutoCompleteContaCorrente.itemSelecionado as ContaCorrente;;
					baixaLancamentoContaPagar.formaPagamento = this.ignComboBoxAutoCompleteFormaPagamento.selectedItem as FormaPagamento;
					baixaLancamentoContaPagar.considerarBaixaIntegral = (this.ignComboBoxFixoConsiderarBaixaIntegral.selectedItem.codigo == "S" ? 1 : 0);
					baixaLancamentoContaPagar.observacao += this.ignTextInputObservacao.text;
					baixaLancamentoContaPagar.dataPagamento = DateField.stringToDate(this.ignTextInputDateDataPagamento.text, "DD/MM/YYYY");
					baixaLancamentoContaPagar.dataLancamento = DateField.stringToDate(this.ignTextInputDateDataLancamento.text, "DD/MM/YYYY");
					baixaLancamentoContaPagar.observacao += " Multiplas baixas. Código de segurança : ";
					var remoteObjectSalvar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("baixaLancamentoContaPagarService", salvarResultHandler);	
					remoteObjectSalvar.getOperation("baixarMultiplosLancamentos").send(this.listaLancamentoContaPagar, baixaLancamentoContaPagar, this.checkBoxValorSaldo.selected);
				}
				catch(e:Error)
				{
					Alert.show("Erro ao salvar as baixas : " + e.message);
				}
			}
			
			private function salvarResultHandler( event: ResultEvent ): void 
			{
				this.dispatchEvent(new Event("BaixaLancamentoContaPagarAtualizadoEvent"));
				Alert.show("Baixa feita com sucesso!");
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			private function atualizarResultHandler( event: ResultEvent ): void 
			{
				this.dispatchEvent(new Event("BaixaLancamentoContaPagarAtualizadoEvent"));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			protected function buttonLimpar_clickHandler(event:MouseEvent):void
			{
				limparListaCampo();
			}
						
			protected function buttonPesquisarContaCorrente_clickHandler(event:MouseEvent):void
			{
				var contaCorrenteComponentePesquisa: ContaCorrenteComponentePesquisa = new ContaCorrenteComponentePesquisa();
				contaCorrenteComponentePesquisa.addEventListener("ContaCorrenteSelecionadoEvent", atualizarContaCorrentePorSelecaoResultHandler);
				UPCPopUpManager.instance.addPopUp(contaCorrenteComponentePesquisa, this, true);
				UPCPopUpManager.instance.centerWindow(contaCorrenteComponentePesquisa);
			}
			
			private function atualizarContaCorrentePorSelecaoResultHandler(e:ResultEvent):void
			{
				var novoContaCorrente: ContaCorrente = e.result as ContaCorrente;
				ignAutoCompleteContaCorrente.itemSelecionado = novoContaCorrente;
			}
			
			protected function buttonAdicionarContaCorrente_clickHandler(event:MouseEvent):void
			{
				var contaCorrenteComponenteCadastro: ContaCorrenteComponenteCadastro = new ContaCorrenteComponenteCadastro();
				contaCorrenteComponenteCadastro.addEventListener("ContaCorrenteIncluidoEvent", atualizarContaCorrentePorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(contaCorrenteComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(contaCorrenteComponenteCadastro);
			}
			
			private function atualizarContaCorrentePorInclusaoResultHandler(e:ResultEvent):void
			{
				var novoContaCorrente: ContaCorrente = e.result as ContaCorrente;
				ignAutoCompleteContaCorrente.itemSelecionado = novoContaCorrente;
			}
			protected function buttonAdicionarFormaPagamento_clickHandler(event:MouseEvent):void
			{
				var formaPagamentoComponenteCadastro: FormaPagamentoComponenteCadastro = new FormaPagamentoComponenteCadastro();
				formaPagamentoComponenteCadastro.addEventListener("FormaPagamentoIncluidoEvent", atualizarListaFormaPagamentoPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(formaPagamentoComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(formaPagamentoComponenteCadastro);
			}
			
			private function atualizarListaFormaPagamentoPorInclusaoResultHandler(e:ResultEvent):void
			{
				var novoFormaPagamento: FormaPagamento = e.result as FormaPagamento;
				listaFormaPagamento.addItem(novoFormaPagamento);
				ignComboBoxAutoCompleteFormaPagamento.selectedItem = novoFormaPagamento;
			}		
			
			protected function titlewindow1_keyDownHandler(event:KeyboardEvent):void
			{
				if(event.keyCode == Keyboard.ENTER)
				{
					var objClassName:String = getQualifiedClassName(focusManager.getNextFocusManagerComponent()).split("::")[0x1];
					
					while(getQualifiedClassName(focusManager.getNextFocusManagerComponent()).split("::")[0x1] == "Button")
					{
						focusManager.getNextFocusManagerComponent().setFocus();						
						
						if(getFocus().name.toUpperCase().indexOf("SALVAR") > 0 || getFocus().name.toUpperCase().indexOf("INCLUIRBAIXA") > 0)
						{
							getFocus().dispatchEvent(new MouseEvent(MouseEvent.CLICK));
							break;
						}
					}
					
					focusManager.getNextFocusManagerComponent().setFocus();
				}
			}
			
			protected function checkBoxValorSaldo_clickHandler(event:MouseEvent):void
			{
				// TODO Auto-generated method stub
				
			}
			
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<s:ArrayCollection id="listaOpcaoSimNao">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="Sim"/>
			<fx:Object codigo="N" valor="Não"/>
		</s:ArrayCollection>
		
		<mx:DateFormatter id="dataPadrao" formatString="DD/MM/YYYY"/>
	</fx:Declarations>
	
<mx:VBox x="10" y="10">
	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="720" width="100%">
		<mx:GridRow backgroundColor="#CDC9C9" backgroundAlpha="0.5" width="100%">
			<mx:GridItem>
				<mx:HBox>
					<s:Label text="Informe os dados"/>
				</mx:HBox>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Forma Pagamento:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor" colSpan="6">
				<s:VGroup>
					<s:Label id="labelValidacaoFormaPagamento" styleName="labelValidacao" text="{ignComboBoxAutoCompleteFormaPagamento.errorString}"/>
					<s:HGroup>
						<visual:IgnComboBoxAutoComplete id="ignComboBoxAutoCompleteFormaPagamento" dataProvider="{listaFormaPagamento}" labelField="descricao" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}" width="430"/>
						<s:Button id="buttonAdicionarFormaPagamento" width="30" label="+" click="buttonAdicionarFormaPagamento_clickHandler(event)"/>
					</s:HGroup>
				</s:VGroup>
			</mx:GridItem>		
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Conta Banco/Caixa:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor" colSpan="6">
				<s:VGroup>
					<s:Label id="labelValidacaoContaCorrente" styleName="labelValidacao" text="{ignAutoCompleteContaCorrente.errorString}"/>
					<s:HGroup>
						<autoComplete:IgnAutoComplete idKeyName="numeroConta" palavraChave="descricao" id="ignAutoCompleteContaCorrente" enviarArgumentos="true" destino="contaCorrenteService" funcaoChamada="listarPorObjetoFiltro" lenStartConsulta="3"  nomeClasseObjetoFiltro="br.com.desenv.nepalign.vo.ContaCorrente" tabEnabled="true" buscarTambemPorChave="true" width="390" obrigatorio="true"/>  
						<s:Button id="buttonPesquisarContaCorrente" width="30" label="..." click="buttonPesquisarContaCorrente_clickHandler(event)"/>
						<s:Button id="buttonAdicionarContaCorrente" width="30" label="+" click="buttonAdicionarContaCorrente_clickHandler(event)"/>
					</s:HGroup>
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Considerar Baixa Integral:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoConsiderarBaixaIntegral" styleName="labelValidacao" text="{ignComboBoxFixoConsiderarBaixaIntegral.errorString}"/>
					<visual:IgnComboBoxFixo id="ignComboBoxFixoConsiderarBaixaIntegral" obrigatorio="true"  dataProvider="{listaOpcaoSimNao}"  listaValidadorForm="{this.listaValidadorForm}"/> 
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Dt. Lancamento:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoDataLancamento" styleName="labelValidacao" text="{ignTextInputDateDataLancamento.errorString}"/>
					<visual:IgnTextInputDate id="ignTextInputDateDataLancamento" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Dt. Pgto:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoDataPagamento" styleName="labelValidacao" text="{ignTextInputDateDataPagamento.errorString}"/>
					<visual:IgnTextInputDate id="ignTextInputDateDataPagamento" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow width="300">
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Observação:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor" colSpan="6">
				<s:VGroup>
					<s:Label id="labelValidacaoObservacao" styleName="labelValidacao" text="{ignTextInputObservacao.errorString}"/>
					<visual:IgnTextArea id="ignTextInputObservacao" heightInLines="3" maxChars="255" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}" width="460"/>
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow height="0">
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow width="100%">
			<mx:GridItem colSpan="8" horizontalAlign="right">
				<s:CheckBox id="checkBoxValorSaldo" label="Baixar apenas o Valor de Saldo (Valor restante)"/>
				<s:Button id="buttonSalvar" label="Salvar" click="buttonSalvar_clickHandler(event)"/>
				<s:Spacer height="0" width="5"/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow height="0">
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
	</mx:Grid>
</mx:VBox>
</s:TitleWindow>